package me.akito123321.valoStrats.rest;

import java.net.InetAddress;
import java.net.UnknownHostException;

import org.springframework.boot.web.server.ConfigurableWebServerFactory;
import org.springframework.boot.web.server.WebServerFactoryCustomizer;
import org.springframework.stereotype.Component;

import me.akito123321.valoStrats.ValoStratsApplication;


@Component
public class ServerConfig implements WebServerFactoryCustomizer<ConfigurableWebServerFactory> {

	@Override
	public void customize(ConfigurableWebServerFactory factory) {
		factory.setPort(ValoStratsApplication.config.port());
		try {
			factory.setAddress(InetAddress.getByName(ValoStratsApplication.config.host()));
		} catch (UnknownHostException e) {
			throw new RuntimeException("Failed to config port", e);
		}
	}

}
