package me.akito123321.valoStrats.schemas;

import java.util.ArrayList;
import java.util.List;

import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;

@Entity(name = "wishlist_group")
public class Group {
	@Id
	@GeneratedValue(strategy = GenerationType.UUID)
	private String id;
	private String name;
	@ManyToOne
	private StratsUser owner;
	@ManyToMany(fetch = FetchType.EAGER)
	private List<StratsUser> members;
	@OneToMany(fetch = FetchType.EAGER)
	private List<Strat> strats;

	@OneToMany(fetch = FetchType.EAGER)
	private List<Map> maps;

	@ManyToMany(fetch = FetchType.EAGER)
	private List<Profile> profiles;
	
	@ElementCollection(fetch = FetchType.EAGER)
	private List<String> stratTypes;

	public Group(String name, StratsUser owner) {
		this.name = name;
		this.owner = owner;
		this.members = new ArrayList<StratsUser>();
		this.strats = new ArrayList<Strat>();
		this.maps = new ArrayList<Map>();
		this.profiles = new ArrayList<Profile>();
		this.stratTypes = new ArrayList<String>();
	}

	public Group() {

	}

	public String getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public StratsUser getOwner() {
		return owner;
	}

	public List<StratsUser> getMembers() {
		return members;
	}

	public List<Strat> getStrats() {
		return strats;
	}

	public void setName(String name) {
		this.name = name;
	}

	public List<String> getStratTypes() {
		return stratTypes;
	}

	public List<Map> getMaps() {
		return maps;
	}

	public List<Profile> getProfiles() {
		return profiles;
	}

}
